package com.hai.dao;

import com.hai.entity.HighMerchantStore;
import com.hai.entity.HighMerchantStoreExample.Criteria;
import com.hai.entity.HighMerchantStoreExample.Criterion;
import com.hai.entity.HighMerchantStoreExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighMerchantStoreSqlProvider {

    public String countByExample(HighMerchantStoreExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_merchant_store");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighMerchantStoreExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_merchant_store");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighMerchantStore record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_merchant_store");
        
        if (record.getType() != null) {
            sql.VALUES("`type`", "#{type,jdbcType=INTEGER}");
        }
        
        if (record.getSourceType() != null) {
            sql.VALUES("source_type", "#{sourceType,jdbcType=INTEGER}");
        }
        
        if (record.getBrandId() != null) {
            sql.VALUES("brand_id", "#{brandId,jdbcType=BIGINT}");
        }
        
        if (record.getBrandName() != null) {
            sql.VALUES("brand_name", "#{brandName,jdbcType=VARCHAR}");
        }
        
        if (record.getRegionId() != null) {
            sql.VALUES("region_id", "#{regionId,jdbcType=BIGINT}");
        }
        
        if (record.getRegionName() != null) {
            sql.VALUES("region_name", "#{regionName,jdbcType=VARCHAR}");
        }
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantId() != null) {
            sql.VALUES("merchant_id", "#{merchantId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreLogo() != null) {
            sql.VALUES("store_logo", "#{storeLogo,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreKey() != null) {
            sql.VALUES("store_key", "#{storeKey,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreName() != null) {
            sql.VALUES("store_name", "#{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreDesc() != null) {
            sql.VALUES("store_desc", "#{storeDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getTelephone() != null) {
            sql.VALUES("telephone", "#{telephone,jdbcType=VARCHAR}");
        }
        
        if (record.getContactName() != null) {
            sql.VALUES("contact_name", "#{contactName,jdbcType=VARCHAR}");
        }
        
        if (record.getAddress() != null) {
            sql.VALUES("address", "#{address,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getLongitude() != null) {
            sql.VALUES("longitude", "#{longitude,jdbcType=VARCHAR}");
        }
        
        if (record.getLatitude() != null) {
            sql.VALUES("latitude", "#{latitude,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceSn() != null) {
            sql.VALUES("device_sn", "#{deviceSn,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceKey() != null) {
            sql.VALUES("device_key", "#{deviceKey,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceName() != null) {
            sql.VALUES("device_name", "#{deviceName,jdbcType=VARCHAR}");
        }
        
        if (record.getPrestoreType() != null) {
            sql.VALUES("prestore_type", "#{prestoreType,jdbcType=INTEGER}");
        }
        
        if (record.getOperatorId() != null) {
            sql.VALUES("operator_id", "#{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.VALUES("operator_name", "#{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighMerchantStoreExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("`type`");
        sql.SELECT("source_type");
        sql.SELECT("brand_id");
        sql.SELECT("brand_name");
        sql.SELECT("region_id");
        sql.SELECT("region_name");
        sql.SELECT("company_id");
        sql.SELECT("merchant_id");
        sql.SELECT("store_logo");
        sql.SELECT("store_key");
        sql.SELECT("store_name");
        sql.SELECT("store_desc");
        sql.SELECT("telephone");
        sql.SELECT("contact_name");
        sql.SELECT("address");
        sql.SELECT("`status`");
        sql.SELECT("longitude");
        sql.SELECT("latitude");
        sql.SELECT("device_sn");
        sql.SELECT("device_key");
        sql.SELECT("device_name");
        sql.SELECT("prestore_type");
        sql.SELECT("operator_id");
        sql.SELECT("operator_name");
        sql.SELECT("update_time");
        sql.SELECT("create_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_merchant_store");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighMerchantStore record = (HighMerchantStore) parameter.get("record");
        HighMerchantStoreExample example = (HighMerchantStoreExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_merchant_store");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        }
        
        if (record.getSourceType() != null) {
            sql.SET("source_type = #{record.sourceType,jdbcType=INTEGER}");
        }
        
        if (record.getBrandId() != null) {
            sql.SET("brand_id = #{record.brandId,jdbcType=BIGINT}");
        }
        
        if (record.getBrandName() != null) {
            sql.SET("brand_name = #{record.brandName,jdbcType=VARCHAR}");
        }
        
        if (record.getRegionId() != null) {
            sql.SET("region_id = #{record.regionId,jdbcType=BIGINT}");
        }
        
        if (record.getRegionName() != null) {
            sql.SET("region_name = #{record.regionName,jdbcType=VARCHAR}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantId() != null) {
            sql.SET("merchant_id = #{record.merchantId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreLogo() != null) {
            sql.SET("store_logo = #{record.storeLogo,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreKey() != null) {
            sql.SET("store_key = #{record.storeKey,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreDesc() != null) {
            sql.SET("store_desc = #{record.storeDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getTelephone() != null) {
            sql.SET("telephone = #{record.telephone,jdbcType=VARCHAR}");
        }
        
        if (record.getContactName() != null) {
            sql.SET("contact_name = #{record.contactName,jdbcType=VARCHAR}");
        }
        
        if (record.getAddress() != null) {
            sql.SET("address = #{record.address,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getLongitude() != null) {
            sql.SET("longitude = #{record.longitude,jdbcType=VARCHAR}");
        }
        
        if (record.getLatitude() != null) {
            sql.SET("latitude = #{record.latitude,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceSn() != null) {
            sql.SET("device_sn = #{record.deviceSn,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceKey() != null) {
            sql.SET("device_key = #{record.deviceKey,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceName() != null) {
            sql.SET("device_name = #{record.deviceName,jdbcType=VARCHAR}");
        }
        
        if (record.getPrestoreType() != null) {
            sql.SET("prestore_type = #{record.prestoreType,jdbcType=INTEGER}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_merchant_store");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        sql.SET("source_type = #{record.sourceType,jdbcType=INTEGER}");
        sql.SET("brand_id = #{record.brandId,jdbcType=BIGINT}");
        sql.SET("brand_name = #{record.brandName,jdbcType=VARCHAR}");
        sql.SET("region_id = #{record.regionId,jdbcType=BIGINT}");
        sql.SET("region_name = #{record.regionName,jdbcType=VARCHAR}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("merchant_id = #{record.merchantId,jdbcType=BIGINT}");
        sql.SET("store_logo = #{record.storeLogo,jdbcType=VARCHAR}");
        sql.SET("store_key = #{record.storeKey,jdbcType=VARCHAR}");
        sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        sql.SET("store_desc = #{record.storeDesc,jdbcType=VARCHAR}");
        sql.SET("telephone = #{record.telephone,jdbcType=VARCHAR}");
        sql.SET("contact_name = #{record.contactName,jdbcType=VARCHAR}");
        sql.SET("address = #{record.address,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("longitude = #{record.longitude,jdbcType=VARCHAR}");
        sql.SET("latitude = #{record.latitude,jdbcType=VARCHAR}");
        sql.SET("device_sn = #{record.deviceSn,jdbcType=VARCHAR}");
        sql.SET("device_key = #{record.deviceKey,jdbcType=VARCHAR}");
        sql.SET("device_name = #{record.deviceName,jdbcType=VARCHAR}");
        sql.SET("prestore_type = #{record.prestoreType,jdbcType=INTEGER}");
        sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighMerchantStoreExample example = (HighMerchantStoreExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighMerchantStore record) {
        SQL sql = new SQL();
        sql.UPDATE("high_merchant_store");
        
        if (record.getType() != null) {
            sql.SET("`type` = #{type,jdbcType=INTEGER}");
        }
        
        if (record.getSourceType() != null) {
            sql.SET("source_type = #{sourceType,jdbcType=INTEGER}");
        }
        
        if (record.getBrandId() != null) {
            sql.SET("brand_id = #{brandId,jdbcType=BIGINT}");
        }
        
        if (record.getBrandName() != null) {
            sql.SET("brand_name = #{brandName,jdbcType=VARCHAR}");
        }
        
        if (record.getRegionId() != null) {
            sql.SET("region_id = #{regionId,jdbcType=BIGINT}");
        }
        
        if (record.getRegionName() != null) {
            sql.SET("region_name = #{regionName,jdbcType=VARCHAR}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantId() != null) {
            sql.SET("merchant_id = #{merchantId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreLogo() != null) {
            sql.SET("store_logo = #{storeLogo,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreKey() != null) {
            sql.SET("store_key = #{storeKey,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreDesc() != null) {
            sql.SET("store_desc = #{storeDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getTelephone() != null) {
            sql.SET("telephone = #{telephone,jdbcType=VARCHAR}");
        }
        
        if (record.getContactName() != null) {
            sql.SET("contact_name = #{contactName,jdbcType=VARCHAR}");
        }
        
        if (record.getAddress() != null) {
            sql.SET("address = #{address,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getLongitude() != null) {
            sql.SET("longitude = #{longitude,jdbcType=VARCHAR}");
        }
        
        if (record.getLatitude() != null) {
            sql.SET("latitude = #{latitude,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceSn() != null) {
            sql.SET("device_sn = #{deviceSn,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceKey() != null) {
            sql.SET("device_key = #{deviceKey,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceName() != null) {
            sql.SET("device_name = #{deviceName,jdbcType=VARCHAR}");
        }
        
        if (record.getPrestoreType() != null) {
            sql.SET("prestore_type = #{prestoreType,jdbcType=INTEGER}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighMerchantStoreExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}